;   -1    
;
;    ,    
; 30  8950 ,     VFO,   
;      ,   VFOA  VFOB
;     - 100 
; 6-  LED    
;
;7-       -1 
;==========================================================
;  .. (UA3VVM)
; 03/2017
; RC = 2000000 Hz
; RC  2 

	.include "m8def.inc"		; Use AtMega8A

	.def 	Temp0 	= R15		;   
	.def 	Temp1 	= R16
	.def 	Temp2 	= R17
	.def 	freqL 	= R18		;   
	.def 	freqM 	= R19
	.def 	freqH 	= R20
	.def 	rit_c 	= R21		;    
	.def 	Temp3 	= R22
	.def 	Temp4 	= R23
	
	
	.def	LBtemp	= r1		;     
	.def	MBtemp	= r2
	.def	HBtemp	= r3
		
	.def	LBcpi	= r4		;      
	.def	MBcpi	= r5
	.def	HBcpi	= r6
	
	.def	LowByte	= r7
	.def	HighByte= r8
	
	.def	PCHlow	= r9		;  = 10702 
	.def	PCHhigh	= r10
	
	.def	select	= r14		;       
	
	
	
;   32/32	
.def    dv32u0     =r16    ; divisor byte 0 (LSB)
.def    dv32u1     =r17    ; divisor byte 1
.def    dv32u2     =r18    ; divisor byte 2
.def    dv32u3     =r19    ; divisor byte 3 (MSB)
.def    dres32u0 =r20    ; result byte 0 (LSB)
.def    dres32u1 =r21    ; result byte 1
.def    dres32u2 =r22    ; result byte 2
.def    dres32u3 =r23    ; result byte 3 (MSB)
.def    dd32u0     =r20    ; dividend byte 0 (LSB)
.def    dd32u1     =r21    ; dividend byte 1
.def    dd32u2     =r22    ; dividend byte 2
.def    dd32u3     =r23    ; dividend byte 3 (MSB)
.def    drem32u0 =r24    ; remainder byte 0 (LSB)
.def    drem32u1 =r25    ; remainder byte 1
.def    drem32u2 =r26    ; remainder byte 2
.def    drem32u3 =r27    ; remainder byte 3 (MSB)
.def    dcnt32u  =r28    ; loop counter

.def     NewState = R11	;        
.def     OldState = R12	;      
.def     Count    = R13	; 

	
;=================================================
	.equ	SegPORT = PORTD
	
	.equ	pll_clock	=2	;    B
	.equ	pll_enable	=1	;     
	.equ	pll_data	=0	;  
		
;	
;=================================================
;  SRAM 
.DSEG
	Digits:  	.byte	5
	vfoA:		.byte	3
	vfoB:		.byte	3
	dac:		.byte	1	;       100 					
;=================================================
;  EEPROM 
;.ESEG
;	eDigits:  	.byte	5					
;=================================================
;  FLASH 
.CSEG
;=================================================
;  
.org 0x00
		RJMP	RESET
.org	ovf1addr	;   T/1
		rjmp clock
.org	OVF0addr	;   T0
		rjmp scan_keys


;****************************************************		
RESET:	
	;  
	LDI 	Temp1, LOW(RAMEND)
	OUT 	SPL, Temp1
	LDI 	Temp1, HIGH(RAMEND)	
	OUT 	SPH, Temp1
	
	rcall	long_delay	;1.0s

	clr	temp0	;0
	clr	count	;0
	ldi	rit_c, 1		; 

	rcall port_init	;  -

;  
;   = 4998.0 
ldi freqL, $3C
ldi freqM, $C3
ldi freqH, 0
;  

	;   = 3500.0 
;	ldi freqL, $B8
;	ldi freqM, $88
;	ldi freqH, 0
	
	ldi temp1, $D0		;     10704 khz
	mov PCHlow, temp1
	ldi temp1, $29
	mov PCHhigh, temp1
	
	sts vfoA,	freqL	;   VFO   
	sts vfoA+1,	freqM
	sts vfoA+2,	freqH
	
	sts vfoB,	freqL
	sts vfoB+1,	freqM
	sts vfoB+2,	freqH
	
;  
clr temp2
sts dac, temp2
;  
	
	rcall	convert
	rcall	select_gun	;        
	rcall	sel_serial	;        (  )
	rcall	select_hz	;     
	rcall	serial_100hz	;       
	rcall	Div32		;      10         1 

;***************   "" *********************************
	ldi temp2,16		;     PLL
	ldi temp1, $d5
	mov LBtemp, temp1	;1-    
	ldi temp1, $81
	mov MBtemp, temp1	;  "" (16 )+Lock:1,current factor 0,023ma
	rcall DATA_TO_PLL	;   ""
	
	ldi temp2,16		;     PLL
	mov LBtemp,LowByte
	mov MBtemp,HighByte
	rcall DATA_TO_PLL	;   "" (16 )
;**************************************************************************
	
	rcall time_init	;  T0/T1
			;T0 -  
			;T1 -  
	sei	; 
;=============================================================================
loop:
	rjmp loop
	
	
;*******************************
scan_keys:
	push temp1
	in temp1,sreg
	push temp1
	
;*******************************************************
;encoder:

;in temp1,PINB ;     
;cbr temp1,0b10011111 ;  
;mov NewState,temp1

;lsr NewState	;  5 ,   0  1  
;lsr NewState
;lsr NewState
;lsr NewState
;lsr NewState


;     4- :
;1)         ? 
;cp OldState, temp0 	;  
;brne Cpi1 ;     
;	ldi temp1, 2
;	cp NewState, temp1
;	brne Cpi11
;	rcall RightShift
;	Cpi11:
;	ldi temp1, 1
;	cp NewState, temp1
;	brne Cpi12
;	rcall LeftShift
;	Cpi12:
;	mov OldState,NewState ;     ,  ...
;	rjmp check_keys

;Cpi1:
;2)     =1     =0 ? 
;ldi temp1, 1
;cp OldState, temp1
;brne Cpi2 ;     
;	cp NewState, temp0	;0
;	brne Cpi21
;	rcall RightShift
;	Cpi21:
;	ldi temp1, 3
;	cp NewState, temp1
;	brne Cpi22
;	rcall LeftShift
;	Cpi22:
;	mov OldState,NewState ;     ,  ...
;	rjmp check_keys

;Cpi2:
;3 )      =1    =0 ?
;ldi temp1, 2
;cp OldState, temp1
;brne Cpi3 ;     
;	ldi temp1, 3
;	cp NewState, temp1
;	brne Cpi31
;	rcall RightShift
;	Cpi31:
;	cp NewState, temp0
;	brne Cpi12
;	rcall LeftShift
;	Cpi32:
;	mov OldState,NewState ;     ,  ...
;	rjmp check_keys

;Cpi3:
;4)     =1 ?
;ldi temp1, 3 
;cp OldState, temp1
;brne Cpi4 ;      
;	ldi temp1, 1
;	cp NewState, temp1
;	brne Cpi41
;	rcall RightShift
;	Cpi41:
;	ldi temp1, 2
;	cp NewState, temp1
;	brne Cpi42
;	rcall LeftShift
;	Cpi42:
;	mov OldState,NewState ;     ,  ...
;Cpi4:
;	rjmp check_keys

	
;**************************
;   
;**************************
check_keys:
	sbic 	PIND,2		;   plus ?
	rjmp 	key2		;  ,    
	rjmp	plus
key2:
	sbic 	PIND,3		;   minus ?
	rjmp	key3		;  ,    
	rjmp	minus
key3:
	sbic 	PIND,4		;   plus10 ?
	rjmp	key4		;  ,    
	rjmp	plus10
key4:
	sbic 	PIND,5		;   minus10 ?
	rjmp	key5		;  ,    
	rjmp	minus10
key5:
	sbic 	PIND,6		;   rit ?
	rjmp	key6		;  ,    
	rjmp	rit
key6:
	sbic 	PIND,7		;    VFOB ?
	rjmp	key7		;  ,    PTT
	rjmp	clrVFOB
key7:
	sbic 	PINB,7		;   PTT ?
	rjmp 	key8		;  ,    
	rjmp	pttON
key8:
	sbic 	PINB,5		;   minus1 ?
	rjmp 	key9		;  ,    
	rjmp	minus1
key9:
	sbic 	PINB,6		;   plus1 ?
	rjmp 	exit_scan	;  ,    
	rjmp	plus1	
exit_scan:
	ldi	temp1, 1
	cp	r14, temp1
	breq	rx
	rjmp	clrRX
rx:
	lds freqL,	vfoB	
	lds freqM,	vfoB+1	
	lds freqH,	vfoB+2
	
	rcall	convert
	rcall	select_gun	;        
	rcall	sel_serial	;        (  )
	rcall	select_hz	;     
	rcall	serial_100hz	;       
	rcall	Div32	;      10         1 

;***************   "" *********************************
	ldi temp2,16		;     PLL
	ldi temp1, $d5
	mov LBtemp, temp1	;1-    
	ldi temp1, $81
	mov MBtemp, temp1	;  "" (16 )+Lock:1,current factor 0,023ma
	rcall DATA_TO_PLL	;   ""
	
	ldi temp2,16		;     PLL
	mov LBtemp,LowByte
	mov MBtemp,HighByte
	rcall DATA_TO_PLL	;   "" (16 )
;**************************************************************************
	clr r14		;    PTT	
clrRX:
	pop temp1
	out sreg,temp1
	pop temp1
	reti				
		
;*******************************************************
;       
;*******************************************************
plus:
	cpi rit_c,1	;   
	breq rit_off2
	cpi rit_c,2	;   
	breq rit_on2
rit_off2:	
	ldi temp1, $e8	;low 1000
	ldi temp2, $03	;high
	add freqL,temp1	;low
	adc freqM,temp2	;high
	adc freqH,temp0	;high
	
	rcall check_num
	
	sts vfoA,	freqL
	sts vfoA+1,	freqM
	sts vfoA+2,	freqH
	
	rcall	convert
	rcall	select_gun	;        
	rcall	sel_serial	;        (  )
;	rcall	select_hz	;     
;	rcall	serial_100hz	;       
	rcall	Div32	;      10         1 

;***************   "" *********************************
	ldi temp2,16		;     PLL
	ldi temp1, $d5
	mov LBtemp, temp1	;1-    
	ldi temp1, $81
	mov MBtemp, temp1	;  "" (16 )+Lock:1,current factor 0,023ma
	rcall DATA_TO_PLL	;   ""
	
	ldi temp2,16		;     PLL
	mov LBtemp,LowByte
	mov MBtemp,HighByte
	rcall DATA_TO_PLL	;   "" (16 )
;**************************************************************************

	pop temp1
	out sreg,temp1
	pop temp1
	reti
rit_on2:
	ldi temp1, $e8	;low 1000
	ldi temp2, $03	;high
	add freqL,temp1	;low
	adc freqM,temp2	;high
	adc freqH,temp0	;high
	
	rcall check_num
	
	sts vfoB,	freqL
	sts vfoB+1,	freqM
	sts vfoB+2,	freqH
	
	rcall	convert
	rcall	select_gun	;        
	rcall	sel_serial	;        (  )
;	rcall	select_hz	;     
;	rcall	serial_100hz	;       
	rcall	Div32	;      10         1 

;***************   "" *********************************
	ldi temp2,16		;     PLL
	ldi temp1, $d5
	mov LBtemp, temp1	;1-    
	ldi temp1, $81
	mov MBtemp, temp1	;  "" (16 )+Lock:1,current factor 0,023ma
	rcall DATA_TO_PLL	;   ""
	
	ldi temp2,16		;     PLL
	mov LBtemp,LowByte
	mov MBtemp,HighByte
	rcall DATA_TO_PLL	;   "" (16 )
;**************************************************************************
		
	pop temp1
	out sreg,temp1
	pop temp1
	reti	

;==========================================
minus:
	cpi rit_c,1	;   
	breq rit_off3
	cpi rit_c,2	;   
	breq rit_on3
rit_off3:	
	ldi temp1, $e8	;low 1000
	ldi temp2, $03	;high
	sub freqL,temp1	;low
	sbc freqM,temp2	;high
	sbc freqH,temp0	;high
	
	rcall check_num
	
	sts vfoA,	freqL
	sts vfoA+1,	freqM
	sts vfoA+2,	freqH
	
	rcall	convert
	rcall	select_gun	;        
	rcall	sel_serial	;        (  )
;	rcall	select_hz	;     
;	rcall	serial_100hz	;       
	rcall	Div32	;      10         1 

;***************   "" *********************************
	ldi temp2,16		;     PLL
	ldi temp1, $d5
	mov LBtemp, temp1	;1-    
	ldi temp1, $81
	mov MBtemp, temp1	;  "" (16 )+Lock:1,current factor 0,023ma
	rcall DATA_TO_PLL	;   ""
	
	ldi temp2,16		;     PLL
	mov LBtemp,LowByte
	mov MBtemp,HighByte
	rcall DATA_TO_PLL	;   "" (16 )
;**************************************************************************
	
	pop temp1
	out sreg,temp1
	pop temp1
	reti
rit_on3:
	ldi temp1, $e8	;low 1000
	ldi temp2, $03	;high
	sub freqL,temp1	;low
	sbc freqM,temp2	;high
	sbc freqH,temp0	;high
	
	rcall check_num
	
	sts vfoB,	freqL
	sts vfoB+1,	freqM
	sts vfoB+2,	freqH
	
	rcall	convert
	rcall	select_gun	;        
	rcall	sel_serial	;        (  )
;	rcall	select_hz	;     
;	rcall	serial_100hz	;       
	rcall	Div32	;      10         1 

;***************   "" *********************************
	ldi temp2,16		;     PLL
	ldi temp1, $d5
	mov LBtemp, temp1	;1-    
	ldi temp1, $81
	mov MBtemp, temp1	;  "" (16 )+Lock:1,current factor 0,023ma
	rcall DATA_TO_PLL	;   ""
	
	ldi temp2,16		;     PLL
	mov LBtemp,LowByte
	mov MBtemp,HighByte
	rcall DATA_TO_PLL	;   "" (16 )
;**************************************************************************
		
	pop temp1
	out sreg,temp1
	pop temp1
	reti

;=======================================
plus10:
	cpi rit_c,1	;   
	breq rit_off4
	cpi rit_c,2	;   
	breq rit_on4
rit_off4:	
	ldi temp1, 100
	add freqL,temp1	;low
	adc freqM,temp0	;high
	adc freqH,temp0	;high
	
	rcall check_num
	
	sts vfoA,	freqL
	sts vfoA+1,	freqM
	sts vfoA+2,	freqH
	
	rcall	convert
	rcall	select_gun	;        
	rcall	sel_serial	;        (  )
;	rcall	select_hz	;     
;	rcall	serial_100hz	;       
	rcall	Div32	;      10         1 

;***************   "" *********************************
	ldi temp2,16		;     PLL
	ldi temp1, $d5
	mov LBtemp, temp1	;1-    
	ldi temp1, $81
	mov MBtemp, temp1	;  "" (16 )+Lock:1,current factor 0,023ma
	rcall DATA_TO_PLL	;   ""
	
	ldi temp2,16		;     PLL
	mov LBtemp,LowByte
	mov MBtemp,HighByte
	rcall DATA_TO_PLL	;   "" (16 )
;**************************************************************************
	
	pop temp1
	out sreg,temp1
	pop temp1
	reti
rit_on4:
	ldi temp1, 100
	add freqL,temp1	;low
	adc freqM,temp0	;high
	adc freqH,temp0	;high
	
	rcall check_num
	
	sts vfoB,	freqL
	sts vfoB+1,	freqM
	sts vfoB+2,	freqH
	
	rcall	convert
	rcall	select_gun	;        
	rcall	sel_serial	;        (  )
;	rcall	select_hz	;     
;	rcall	serial_100hz	;       
	rcall	Div32	;      10         1 

;***************   "" *********************************
	ldi temp2,16		;     PLL
	ldi temp1, $d5
	mov LBtemp, temp1	;1-    
	ldi temp1, $81
	mov MBtemp, temp1	;  "" (16 )+Lock:1,current factor 0,023ma
	rcall DATA_TO_PLL	;   ""
	
	ldi temp2,16		;     PLL
	mov LBtemp,LowByte
	mov MBtemp,HighByte
	rcall DATA_TO_PLL	;   "" (16 )
;**************************************************************************
		
	pop temp1
	out sreg,temp1
	pop temp1
	reti	

;===========================================
minus10:
	cpi rit_c,1	;   
	breq rit_off5
	cpi rit_c,2	;   
	breq rit_on5
rit_off5:	
	ldi temp1, 100
	sub freqL,temp1	;low
	sbc freqM,temp0	;high
	sbc freqH,temp0	;high
	
	rcall check_num
	
	sts vfoA,	freqL
	sts vfoA+1,	freqM
	sts vfoA+2,	freqH
	
	rcall	convert
	rcall	select_gun	;        
	rcall	sel_serial	;        (  )
;	rcall	select_hz	;     
;	rcall	serial_100hz	;       
	rcall	Div32	;      10         1 

;***************   "" *********************************
	ldi temp2,16		;     PLL
	ldi temp1, $d5
	mov LBtemp, temp1	;1-    
	ldi temp1, $81
	mov MBtemp, temp1	;  "" (16 )+Lock:1,current factor 0,023ma
	rcall DATA_TO_PLL	;   ""
	
	ldi temp2,16		;     PLL
	mov LBtemp,LowByte
	mov MBtemp,HighByte
	rcall DATA_TO_PLL	;   "" (16 )
;**************************************************************************
	
	pop temp1
	out sreg,temp1
	pop temp1
	reti
rit_on5:
	ldi temp1, 100
	sub freqL,temp1	;low
	sbc freqM,temp0	;high
	sbc freqH,temp0	;high
	
	rcall check_num
	
	sts vfoB,	freqL
	sts vfoB+1,	freqM
	sts vfoB+2,	freqH
	
	rcall	convert
	rcall	select_gun	;        
	rcall	sel_serial	;        (  )
;	rcall	select_hz	;     
;	rcall	serial_100hz	;       
	rcall	Div32	;      10         1 

;***************   "" *********************************
	ldi temp2,16		;     PLL
	ldi temp1, $d5
	mov LBtemp, temp1	;1-    
	ldi temp1, $81
	mov MBtemp, temp1	;  "" (16 )+Lock:1,current factor 0,023ma
	rcall DATA_TO_PLL	;   ""
	
	ldi temp2,16		;     PLL
	mov LBtemp,LowByte
	mov MBtemp,HighByte
	rcall DATA_TO_PLL	;   "" (16 )
;**************************************************************************
		
	pop temp1
	out sreg,temp1
	pop temp1
	reti

;==========================================
rit:
	inc rit_c
	cpi rit_c,1	;   
	breq rit_off
	cpi rit_c,2	;   
	breq rit_on
	ldi rit_c,1	;   
rit_off:
	lds freqL,	vfoA	
	lds freqM,	vfoA+1	
	lds freqH,	vfoA+2
	
	rcall	convert
	rcall	select_gun	;        
	rcall	sel_serial	;        (  )
;	rcall	select_hz	;     
;	rcall	serial_100hz	;       
	rcall	Div32	;      10         1 

;***************   "" *********************************
	ldi temp2,16		;     PLL
	ldi temp1, $d5
	mov LBtemp, temp1	;1-    
	ldi temp1, $81
	mov MBtemp, temp1	;  "" (16 )+Lock:1,current factor 0,023ma
	rcall DATA_TO_PLL	;   ""
	
	ldi temp2,16		;     PLL
	mov LBtemp,LowByte
	mov MBtemp,HighByte
	rcall DATA_TO_PLL	;   "" (16 )
;**************************************************************************

	pop temp1
	out sreg,temp1
	pop temp1
	reti
rit_on:
	lds freqL,	vfoB	
	lds freqM,	vfoB+1	
	lds freqH,	vfoB+2
	
	rcall	convert
	rcall	select_gun	;        
	rcall	sel_serial	;        (  )
;	rcall	select_hz	;     
;	rcall	serial_100hz	;       
	rcall	Div32	;      10         1 

;***************   "" *********************************
	ldi temp2,16		;     PLL
	ldi temp1, $d5
	mov LBtemp, temp1	;1-    
	ldi temp1, $81
	mov MBtemp, temp1	;  "" (16 )+Lock:1,current factor 0,023ma
	rcall DATA_TO_PLL	;   ""
	
	ldi temp2,16		;     PLL
	mov LBtemp,LowByte
	mov MBtemp,HighByte
	rcall DATA_TO_PLL	;   "" (16 )
;**************************************************************************	

	pop temp1
	out sreg,temp1
	pop temp1
	reti
	
;=============================================================
clrVFOB:
	lds freqL,	vfoA	
	lds freqM,	vfoA+1	
	lds freqH,	vfoA+2
	
	sts vfoB,	freqL
	sts vfoB+1,	freqM
	sts vfoB+2,	freqH
	
	rcall	convert
	rcall	select_gun	;        
	rcall	sel_serial	;        (  )
;	rcall	select_hz	;     
;	rcall	serial_100hz	;       
	rcall	Div32	;      10         1 

;***************   "" *********************************
	ldi temp2,16		;     PLL
	ldi temp1, $d5
	mov LBtemp, temp1	;1-    
	ldi temp1, $81
	mov MBtemp, temp1	;  "" (16 )+Lock:1,current factor 0,023ma
	rcall DATA_TO_PLL	;   ""
	
	ldi temp2,16		;     PLL
	mov LBtemp,LowByte
	mov MBtemp,HighByte
	rcall DATA_TO_PLL	;   "" (16 )
;**************************************************************************
	rcall long_delay	; 0,5   

	pop temp1
	out sreg,temp1
	pop temp1
	reti
	
;============================================================
pttON:
	cpi rit_c,1	;   
	breq rit_off6
	cpi rit_c,2	;   
	breq rit_on6
rit_off6:
	pop temp1
	out sreg,temp1
	pop temp1
	reti
rit_on6:
	lds freqL,	vfoA	
	lds freqM,	vfoA+1	
	lds freqH,	vfoA+2
	
	rcall	convert
	rcall	select_gun	;        
	rcall	sel_serial	;        (  )
;	rcall	select_hz	;     
;	rcall	serial_100hz	;       
	rcall	Div32	;      10         1 

;***************   "" *********************************
	ldi temp2,16		;     PLL
	ldi temp1, $d5
	mov LBtemp, temp1	;1-    
	ldi temp1, $81
	mov MBtemp, temp1	;  "" (16 )+Lock:1,current factor 0,023ma
	rcall DATA_TO_PLL	;   ""
	
	ldi temp2,16		;     PLL
	mov LBtemp,LowByte
	mov MBtemp,HighByte
	rcall DATA_TO_PLL	;   "" (16 )
;**************************************************************************
	ldi temp1,1
	mov r14,temp1	;   PTT

	pop temp1
	out sreg,temp1
	pop temp1
	reti
	
;===========================================
minus1:
	cpi rit_c,1	;   
	breq rit_off8
	cpi rit_c,2	;   
	breq rit_on8
rit_off8:	
	ldi temp1, 1	;low 1
	sub freqL,temp1	;low
	sbc freqM,temp0	;high
	sbc freqH,temp0	;high
	
	sts vfoA,	freqL
	sts vfoA+1,	freqM
	sts vfoA+2,	freqH
	
;  
lds temp2, dac
dec temp2
sts dac, temp2
rcall	convert
rcall	select_gun	;        
rcall	sel_serial	;        (  )
rcall	select_hz	;     
rcall	serial_100hz	;       
rjmp tune
;  
	
	rcall	convert
	rcall	select_gun	;        
	rcall	sel_serial	;        (  )
	rcall	select_hz	;     
	rcall	serial_100hz	;       
	rcall	Div32	;      10         1 

;***************   "" *********************************
	ldi temp2,16		;     PLL
	ldi temp1, $d5
	mov LBtemp, temp1	;1-    
	ldi temp1, $81
	mov MBtemp, temp1	;  "" (16 )+Lock:1,current factor 0,023ma
	rcall DATA_TO_PLL	;   ""
	
	ldi temp2,16		;     PLL
	mov LBtemp,LowByte
	mov MBtemp,HighByte
	rcall DATA_TO_PLL	;   "" (16 )
;**************************************************************************
tune:	
	pop temp1
	out sreg,temp1
	pop temp1
	reti
rit_on8:
	ldi temp1, 1	;low 1
	sub freqL,temp1	;low
	sbc freqM,temp0	;high
	sbc freqH,temp0	;high
	
	sts vfoB,	freqL
	sts vfoB+1,	freqM
	sts vfoB+2,	freqH
	
	rcall	convert
	rcall	select_gun	;        
	rcall	sel_serial	;        (  )
	rcall	select_hz	;     
	rcall	serial_100hz	;       
	rcall	Div32	;      10         1 

;***************   "" *********************************
	ldi temp2,16		;     PLL
	ldi temp1, $d5
	mov LBtemp, temp1	;1-    
	ldi temp1, $81
	mov MBtemp, temp1	;  "" (16 )+Lock:1,current factor 0,023ma
	rcall DATA_TO_PLL	;   ""
	
	ldi temp2,16		;     PLL
	mov LBtemp,LowByte
	mov MBtemp,HighByte
	rcall DATA_TO_PLL	;   "" (16 )
;**************************************************************************
		
	pop temp1
	out sreg,temp1
	pop temp1
	reti
	
;==================================================================
plus1:
	cpi rit_c,1	;   
	breq rit_off9
	cpi rit_c,2	;   
	breq rit_on9
rit_off9:	
	ldi temp1, 1	;low 1
	add freqL,temp1	;low
	adc freqM,temp0	;high
	adc freqH,temp0	;high
	
	sts vfoA,	freqL
	sts vfoA+1,	freqM
	sts vfoA+2,	freqH
	
;  
lds temp2, dac
inc temp2
sts dac, temp2
rcall	convert
rcall	select_gun	;        
rcall	sel_serial	;        (  )
rcall	select_hz	;     
rcall	serial_100hz	;       
rjmp tune1
;  
	
	rcall	convert
	rcall	select_gun	;        
	rcall	sel_serial	;        (  )
	rcall	select_hz	;     
	rcall	serial_100hz	;       
	rcall	Div32	;      10         1 

;***************   "" *********************************
	ldi temp2,16		;     PLL
	ldi temp1, $d5
	mov LBtemp, temp1	;1-    
	ldi temp1, $81
	mov MBtemp, temp1	;  "" (16 )+Lock:1,current factor 0,023ma
	rcall DATA_TO_PLL	;   ""
	
	ldi temp2,16		;     PLL
	mov LBtemp,LowByte
	mov MBtemp,HighByte
	rcall DATA_TO_PLL	;   "" (16 )
;**************************************************************************
tune1:	
	pop temp1
	out sreg,temp1
	pop temp1
	reti
rit_on9:
	ldi temp1, 1	;low 1
	add freqL,temp1	;low
	adc freqM,temp0	;high
	adc freqH,temp0	;high
	
	sts vfoB,	freqL
	sts vfoB+1,	freqM
	sts vfoB+2,	freqH
	
	rcall	convert
	rcall	select_gun	;        
	rcall	sel_serial	;        (  )
	rcall	select_hz	;     
	rcall	serial_100hz	;       
	rcall	Div32	;      10         1 

;***************   "" *********************************
	ldi temp2,16		;     PLL
	ldi temp1, $d5
	mov LBtemp, temp1	;1-    
	ldi temp1, $81
	mov MBtemp, temp1	;  "" (16 )+Lock:1,current factor 0,023ma
	rcall DATA_TO_PLL	;   ""
	
	ldi temp2,16		;     PLL
	mov LBtemp,LowByte
	mov MBtemp,HighByte
	rcall DATA_TO_PLL	;   "" (16 )
;**************************************************************************
		
	pop temp1
	out sreg,temp1
	pop temp1
	reti
	
;*************************************************************
clock:
	push temp1
	in temp1,sreg
	push temp1
	push temp2

	ldi temp1,high($ffff-625);    625 - 50hz
	out tcnt1h,temp1
	ldi temp1,low($ffff-625) ;    625
	out tcnt1l,temp1

	rcall	Display

	pop temp2
	pop temp1
	out sreg,temp1
	pop temp1
	reti

;*************************************************************
;        
Decoder:
	ldi 	ZL, LOW(DcMatrix*2)   
	ldi 	ZH, HIGH(DcMatrix*2)  
	add 	ZL, Temp1                        
    	adc 	ZH, Temp0				
    	lpm 	Temp1, Z                     
	ret

;********************************************************
;  -   
;      temp2
;decoder_decimal:
;	ldi ZL, LOW(decimal*2)   
;	ldi ZH, HIGH(decimal*2)
;	ldi temp1,1
;	sub zl, temp1
;	sbc zh, temp0	;    
;	rol temp2	;   2   
;	inc temp2	;   
;	add ZL, Temp2                        
;   	adc ZH, Temp0	;    
;	lpm temp3,Z+
;	lpm temp4,Z	;      
;			;        
;	ret

;=================================================
;      1 ms
Delay:
; ----------------------------- 
; delaying 2000 cycles:
          ldi  R16, $03
WGLOOP0:  ldi  R17, $dd
WGLOOP1:  dec  R17
          brne WGLOOP1
          dec  R16
          brne WGLOOP0
; ----------------------------- 
; delaying 2 cycles:
          nop
          nop
ret
;============================================	  

long_delay:
push r16
push r17
push r22	  
;     1000000 cycles: 0.5s
; ----------------------------- 
; delaying 1999998 cycles:
          ldi  R16, $09
GLOOP0:   ldi  R17, $BC
GLOOP1:   ldi  R22, $C4
GLOOP2:   dec  R22
          brne GLOOP2
          dec  R17
          brne GLOOP1
          dec  R16
          brne GLOOP0
; ----------------------------- 
; delaying 1 cycles:
         nop
pop r22
pop r17
pop r16
ret

;=================================================
;   
Display:
	cpi rit_c,1	;   
	breq rit_off1
	cpi rit_c,2	;   
	breq rit_on1
rit_off1:
	sbi	portc,1	
	LDS 	Temp1, Digits
	RCALL	Decoder
	rcall	serial8b
	RCALL 	Delay
	cbi	portc,1

	sbi	portc,2			  
	LDS 	Temp1, Digits+1
    	RCALL 	Decoder
    	rcall	serial8b        
    	RCALL 	Delay
	cbi	portc,2   

	sbi	portc,3			  
	LDS 	Temp1, Digits+2
    	RCALL 	Decoder
    	rcall	serial8b               
    	RCALL 	Delay
	cbi	portc,3      

	sbi	portc,4			  
	LDS 	Temp1, Digits+3
    	RCALL 	Decoder
    	ldi	temp2, 0b10000000
    	add	temp1, temp2	; 
    	rcall	serial8b        
	RCALL 	Delay
	cbi	portc,4
	
	sbi	portc,5			  
	LDS 	Temp1, Digits+4
    	RCALL 	Decoder
    	rcall	serial8b        
	RCALL 	Delay
	cbi	portc,5
	ret
rit_on1:
	sbi	portc,0	
	ldi 	Temp1, 0b10001100	;  P
	rcall	serial8b
	RCALL 	Delay
	cbi	portc,0
	
	sbi	portc,1	
	LDS 	Temp1, Digits
	RCALL	Decoder
	rcall	serial8b
	RCALL 	Delay
	cbi	portc,1

	sbi	portc,2			  
	LDS 	Temp1, Digits+1
    	RCALL 	Decoder
    	rcall	serial8b        
    	RCALL 	Delay
	cbi	portc,2   

	sbi	portc,3			  
	LDS 	Temp1, Digits+2
    	RCALL 	Decoder
    	rcall	serial8b               
	RCALL 	Delay
	cbi	portc,3      

	sbi	portc,4			  
	LDS 	Temp1, Digits+3
    	RCALL 	Decoder
    	ldi	temp2, 0b10000000
    	add	temp1, temp2	; 
    	rcall	serial8b        
	RCALL 	Delay
	cbi	portc,4
	
	sbi	portc,5			  
	LDS 	Temp1, Digits+4
    	RCALL 	Decoder
    	rcall	serial8b        
	RCALL 	Delay
	cbi	portc,5
	ret

;============================================================================================
time_init:
	ldi temp1,high($ffff-625);    625 - 50hz
	out tcnt1h,temp1
	ldi temp1,low($ffff-625) ;    625
	out tcnt1l,temp1
           
	ldi temp1,$05		;   - 1024 -7.5hz
	out tccr0,temp1		;T0
	
	ldi temp1,$03		;T1  
	out tccr1b,temp1	; 64 +   1
           
	ldi temp1,(1<<toie1) | (1<<toie0)	;T0 and T1, 0 -   
	out timsk,temp1		;    /1                     
ret				;  

;*************************************
;  
port_init:
	ldi	temp1,0b00000011
	out	ddrd,temp1		;portd    0,1 bit
	sbi	PORTD,2
	sbi	PORTD,3
	sbi	PORTD,4
	sbi	PORTD,5			;    
	sbi	PORTD,6
	sbi	PORTD,7
	
	
	ldi	temp1,0b01111111	; 
	out	ddrc,temp1

	ldi	temp1,0b00011111	;    
	out	ddrb,temp1
	sbi	PORTB,pll_enable	;    
	sbi	PORTB,5			;    
	sbi	PORTB,6
	sbi	PORTB,7			;     PTT
ret

;***********************************************	
convert:
push freqH
push freqM	;  
push freqL

	ldi temp1,$10		;low	 10000
	ldi temp2,$27		;high
	rcall delen
	sts Digits,r25
       		
	ldi temp1,$E8		;low	 1000
	ldi temp2,$03		;high
	rcall delen
	sts Digits+1,r25
       		
	ldi temp1,$64		;low	 100
	ldi temp2,$00		;high
	rcall delen
	sts Digits+2,r25
                   
	ldi temp1,$0A		;low	 10
	ldi temp2,$00		;high
	rcall delen
	sts Digits+3,r25
                
	sts Digits+4,freqL	;  

pop freqL	;  
pop freqM
pop freqH
ret


;**********************
; 
delen:
	ldi r25, -1
SUBii:  inc r25
        sub freqL,temp1	;low
        sbc freqM,temp2	;high
	sbc freqH,temp0	;high

        brsh SUBi1         ;  > 0
        add freqL,temp1	;low
        adc freqM,temp2	;high
	adc freqH,temp0	;high
        ret
SUBi1:
        rjmp SUBii
	ret

;***************************************************
;serial:
;	ldi r24,10	;   
;read_byte:
;	clc
;	ror temp3
;	ror temp4
	   
;brcs C1	;  C=1
;brcc C0	;  =0

;C1: 
;	sbi portb,0		;     
;	
;	sbi portb,2		;     
;	nop
;	cbi portb,2
;	
;	dec r24
;	brne read_byte
;	ret			;    10 
;C0:
;	cbi portb,0		;     
;	
;	sbi portb,2		;     
;	nop
;	cbi portb,2
;	
;	dec r24
;	brne read_byte
;	ret			;    10 
	
;===============================================================
serial8b:
	ldi r24,8	;   
read_byte_:
	clc
	rol temp1
	   
brcs C1_	;  C=1
brcc C0_	;  =0

C1_: 
	sbi portd,0		;     
	
	sbi portd,1		;     
	nop
	cbi portd,1
	
	dec r24
	brne read_byte_
	ret			;    8 
C0_:
	cbi portd,0		;     
	
	sbi portd,1		;     
	nop
	cbi portd,1
	
	dec r24
	brne read_byte_
	ret			;    8 
	
;===============================================================
sel_serial:
	sbi portb,2		;     
	nop			;          
	cbi portb,2		;   -  !

	ldi r24,8		;   
read_byte:
	clc
	rol select
	   
brcs C1	;  C=1
brcc C0	;  =0

C1: 
	sbi portb,0		;     
	
	sbi portb,2		;     
	nop
	cbi portb,2
	
	dec r24
	brne read_byte
	
	nop
	sbi portb,3		;STB,     
	nop
	cbi portb,3
	ret			;    8 
C0:
	cbi portb,0		;     
	
	sbi portb,2		;     
	nop
	cbi portb,2
	
	dec r24
	brne read_byte
	
	nop
	sbi portb,3		;STB,     
	nop
	cbi portb,3
	ret			;    8 
	
;===============================================================
serial_100hz:

;  
lds temp2, dac
;  

	sbi portb,2		;     
	nop			;       
	cbi portb,2		;   -  !

	ldi r24,8		;   
read_byte_hz:
	clc
	rol temp2
	   
brcs C1_hz	;  C=1
brcc C0_hz	;  =0

C1_hz: 
	sbi portb,0		;     
	
	sbi portb,2		;     
	nop
	cbi portb,2
	
	dec r24
	brne read_byte_hz
	
	nop
	sbi portb,4		;STB,     
	nop
	cbi portb,4
	ret			;    8 
C0_hz:
	cbi portb,0		;     
	
	sbi portb,2		;     
	nop
	cbi portb,2
	
	dec r24
	brne read_byte_hz
	
	nop
	sbi portb,4		;STB,     
	nop
	cbi portb,4
	ret			;    8 


;***************************************************************
;reg_out:
;	lds temp2, Digits		; 
;	rcall decoder_decimal
;	rcall serial

;	lds temp2, Digits+1		; 
;	rcall decoder_decimal
;	rcall serial

;	lds temp2, Digits+2		; 
;	rcall decoder_decimal
;	rcall serial

;	lds temp2, Digits+3		; 
;	rcall decoder_decimal
;	rcall serial

;	lds temp2, Digits+4		; 
;	rcall decoder_decimal
;	rcall serial

;	sbi portb,1			;STB,     
;	nop
;	cbi portb,1
;ret

;***********************************************************************
;        30.0  8950.0
;***********************************************************************
check_num:
	ldi temp1, $2c		;30  low
	mov LBtemp, temp1
	ldi temp1, $01
	mov MBtemp, temp1
	ldi temp1, $00
	mov HBtemp, temp1
	
	mov LBcpi,freqL		;   VFO
	mov MBcpi,freqM
	mov HBcpi,freqH
	
	sub LBcpi,LBtemp
	sbc MBcpi,MBtemp
	sbc HBcpi,HBtemp
	brmi error_low
	rjmp nextcpi
error_low:
	ldi freqL, $9c		;8950 khz
	ldi freqM, $5d
	ldi freqH, $01
	ret

nextcpi:

	ldi temp1, $9c		;8950  high
	mov LBtemp, temp1
	ldi temp1, $5d
	mov MBtemp, temp1
	ldi temp1, $01
	mov HBtemp, temp1
	
	mov LBcpi,freqL		;   VFO
	mov MBcpi,freqM
	mov HBcpi,freqH
	
	sub LBtemp,LBcpi
	sbc MBtemp,MBcpi
	sbc HBtemp,HBcpi
	brmi error_up
	ret
error_up:
	ldi freqL, $2c		;30 khz
	ldi freqM, $01
	ldi freqH, $00
	ret
	
;************************************************
;     SAA1057 (0,40 )
; MSB  HBtemp
; LSB  LBtemp
;   bit2 Port B
;  bit3 Port C
;  bit 4 PortC
;************************************************

DATA_TO_PLL:	
	cbi PORTB,pll_enable	;CLBlead
	ldi temp1,2		;1.5  ( 1 )
temp:
	dec temp1
	brne temp
	cbi PORTB,pll_data	;Tlead
	sbi PORTB,pll_enable	;     
	ldi temp1,7		;5 
temp1:
	dec temp1
	brne temp1
	sbi PORTB,pll_clock
	ldi temp1,7		;5 
temp6:
	dec temp1
	brne temp6
	cbi PORTB,pll_clock

PLL_LOOP:
	nop
	lsl LBtemp		;Shift least sig byte to carry
	rol MBtemp		;Shift data through carry
	brcs PLL_DATA_SET	;and write to PLL
	cbi PORTB,pll_data
	rjmp PLL_DATA_CLEAR
PLL_DATA_SET:
	ldi temp1,2		; 2,5 
temp2:
	dec temp1
	brne temp2
	sbi PORTB,pll_data	; 
	ldi temp1,3		; 2,5 
temp3:
	dec temp1
	brne temp3

PLL_DATA_CLEAR:
	ldi temp1,2		; 2,5 
temp8:
	dec temp1
	brne temp8

	sbi PORTB,pll_clock	;and clock data to PLL
	ldi temp1,7		; 5 
temp4:
	dec temp1
	brne temp4
	cbi PORTB,pll_clock	;  
	dec temp2		;repeat till finished	
	brne PLL_LOOP
	ldi temp1,2		; 1,75 
temp7:
	dec temp1
	brne temp7
	nop
	sbi PORTB,pll_data
	cbi PORTB,pll_enable
	nop
	nop
	nop
	nop			; 1 
	sbi PORTB,pll_clock	;  
	nop
	nop
	nop
	nop			;1 
	cbi PORTB,pll_clock	;  
	ldi temp1,7		; 5 
temp5:
	dec temp1
	brne temp5
	sbi PORTB,pll_clock	;    
	sbi PORTB,pll_enable
	ret
	
;***************************************************************
 ;*
;* Div32 == 24/8 Bit Unsigned Division
;*
;* dd32uL::dd32uH / dv32uL::dv32uH = dres32uL::dres32uH (drem32uL::drem32uH)
;*    dividend        divisor        result         remainder
;*  r20r21r22r23  /  r16r17r18r19  =    r20r21r22r23        r24r25r26r27
;*
;***************************************************************
Div32:
push    dv32u0	;     
push    dv32u1
push    dv32u2
push    dv32u3
push    dres32u0
push    dres32u1
push    dres32u2
push    dres32u3
push    dd32u0
push    dd32u1
push    dd32u2
push    dd32u3
push    drem32u0
push    drem32u1
push    drem32u2
push    drem32u3
push    dcnt32u

push freqL	;      
push freqM
push freqH
	
pop dd32u2	;         
pop dd32u1
pop dd32u0

	;   
	ldi dv32u0,10	;
	clr dv32u1
	clr dv32u2
	clr dv32u3
	
	clr dd32u3	;   

	clr    drem32u0    ;clear 4 lower remainde byte
        clr    drem32u1    ;
        clr    drem32u2    ;
        sub    drem32u3,drem32u3;and carry
        ldi    dcnt32u,33        ;init loop counter
d32u_loop:   

    rol    dd32u0                  ;shift left dividend
    rol    dd32u1       
    rol    dd32u2       
    rol    dd32u3       
    dec    dcnt32u               ;decrement loop counter
    breq    Com32                ;if counter zero invert result
    rol    drem32u0              ;shift dividend into remainder
    rol    drem32u1   
    rol    drem32u2   
    rol    drem32u3   
    sub    drem32u0,dv32u0 ;remainder = remainder - divisor
    sbc    drem32u1,dv32u1
    sbc    drem32u2,dv32u2
    sbc    drem32u3,dv32u3
    brcc    d32u_loop           ;clear carry to be shifted into res
    add    drem32u0,dv32u0 ;if result negative
    adc    drem32u1,dv32u1 ; restore remainder
    adc    drem32u2,dv32u2
    adc    drem32u3,dv32u3
rjmp    d32u_loop             ;   set carry to be shifted into res
Com32:                   
    com    dres32u0            ;   (com result)
    com    dres32u1           
    com    dres32u2
    com    dres32u3
Return32u:
mov LowByte, dres32u0		;       
mov HighByte, dres32u1

add LowByte, PCHlow		;           = 10704 
adc HighByte, PCHhigh

pop    dcnt32u
pop    drem32u3
pop    drem32u2
pop    drem32u1
pop    drem32u0
pop    dd32u3
pop    dd32u2
pop    dd32u1
pop    dd32u0
pop    dres32u3
pop    dres32u2
pop    dres32u1
pop    dres32u0
pop    dv32u3
pop    dv32u2
pop    dv32u1
pop    dv32u0	;     

ret

;////////////////////////////////////////////////////////////////

;LeftShift:
;	cpi rit_c,1	;   
;	breq rit_off9
;	cpi rit_c,2	;   
;	breq rit_on9

;rit_off9:
;	ldi temp1, 4
;	cp count, temp1 ;   4 ? 
;	brne exitLS_
;	clr count
	
;	ldi temp1, 1
;	sub freqL,temp1	;low
;	sbc freqM,temp0	;high
;	sbc freqH,temp0	;high
	
;	rcall check_num
	
;	sts vfoA,	freqL
;	sts vfoA+1,	freqM
;	sts vfoA+2,	freqH
	
;	rcall	convert
;	rcall	select_gun	;        
;	rcall	sel_serial	;        (  )
;	rcall	select_hz	;     
;	rcall	serial_100hz	;       
;	rcall	Div32	;      10         1 

;***************   "" *********************************
;	ldi temp2,16		;     PLL
;	ldi temp1, $d5
;	mov LBtemp, temp1	;1-    
;	ldi temp1, $81
;	mov MBtemp, temp1	;  "" (16 )+Lock:1,current factor 0,023ma
;	rcall DATA_TO_PLL	;   ""
	
;	ldi temp2,16		;     PLL
;	mov LBtemp,LowByte
;	mov MBtemp,HighByte
;	rcall DATA_TO_PLL	;   "" (16 )
;**************************************************************************
;	exitLS_:
;	inc count
;ret
	
;rit_on9:
;	ldi temp1, 4
;	cp count, temp1 ;   4 ? 
;	brne exitLS
;	clr count
	
;	ldi temp1, 1
;	sub freqL,temp1	;low
;	sbc freqM,temp0	;high
;	sbc freqH,temp0	;high
	
;	rcall check_num
	
;	sts vfoB,	freqL
;	sts vfoB+1,	freqM
;	sts vfoB+2,	freqH
	
;	rcall	convert
;	rcall	select_gun	;        
;	rcall	sel_serial	;        (  )
;	rcall	select_hz	;     
;	rcall	serial_100hz	;       
;	rcall	Div32	;      10         1 

;***************   "" *********************************
;	ldi temp2,16		;     PLL
;	ldi temp1, $d5
;	mov LBtemp, temp1	;1-    
;	ldi temp1, $81
;	mov MBtemp, temp1	;  "" (16 )+Lock:1,current factor 0,023ma
;	rcall DATA_TO_PLL	;   ""
	
;	ldi temp2,16		;     PLL
;	mov LBtemp,LowByte
;	mov MBtemp,HighByte
;	rcall DATA_TO_PLL	;   "" (16 )
	;//////////////////  /////////////
;	exitLS:
;	inc count
;ret

;RightShift:
;	cpi rit_c,1	;   
;	breq rit_off8
;	cpi rit_c,2	;   
;	breq rit_on8

;rit_off8:
;	ldi temp1, 4
;	cp count, temp1 ;   4 ? 
;	brne exitRS_
;	clr count
	
;	ldi temp1, 1
;	add freqL,temp1	;low
;	adc freqM,temp0	;high
;	adc freqH,temp0	;high
	
;	rcall check_num
	
;	sts vfoA,	freqL
;	sts vfoA+1,	freqM
;	sts vfoA+2,	freqH
	
;	rcall	convert
;	rcall	select_gun	;        
;	rcall	sel_serial	;        (  )
;	rcall	select_hz	;     
;	rcall	serial_100hz	;       
;	rcall	Div32	;      10         1 

;***************   "" *********************************
;	ldi temp2,16		;     PLL
;	ldi temp1, $d5
;	mov LBtemp, temp1	;1-    
;	ldi temp1, $81
;	mov MBtemp, temp1	;  "" (16 )+Lock:1,current factor 0,023ma
;	rcall DATA_TO_PLL	;   ""
	
;	ldi temp2,16		;     PLL
;	mov LBtemp,LowByte
;	mov MBtemp,HighByte
;	rcall DATA_TO_PLL	;   "" (16 )
;**************************************************************************
;	exitRS_:
;	inc count
;ret

;rit_on8:
;	ldi temp1, 4
;	cp count, temp1 ;   4 ? 
;	brne exitRS
;	clr count
	
;	ldi temp1, 1
;	add freqL,temp1	;low
;	adc freqM,temp0	;high
;	adc freqH,temp0	;high
	
;	rcall check_num
	
;	sts vfoB,	freqL
;	sts vfoB+1,	freqM
;	sts vfoB+2,	freqH
	
;	rcall	convert
;	rcall	select_gun	;        
;	rcall	sel_serial	;        (  )
;	rcall	select_hz	;     
;	rcall	serial_100hz	;       
;	rcall	Div32	;      10         1 

;***************   "" *********************************
;	ldi temp2,16		;     PLL
;	ldi temp1, $d5
;	mov LBtemp, temp1	;1-    
;	ldi temp1, $81
;	mov MBtemp, temp1	;  "" (16 )+Lock:1,current factor 0,023ma
;	rcall DATA_TO_PLL	;   ""
	
;	ldi temp2,16		;     PLL
;	mov LBtemp,LowByte
;	mov MBtemp,HighByte
;	rcall DATA_TO_PLL	;   "" (16 )
;**************************************************************************
	;//////////////////  /////////////
;	exitRS:
;	inc count
;ret

;**************************************************************************
select_gun:
	push freqL		;     
	push freqM
	push freqH

	ldi temp1, $20		;2000.0 khz
	ldi temp2, $4e
	ldi temp3, $00
	
	sub freqL, temp1	;low
	sbc freqM, temp2	;high
	sbc freqH, temp3	;high
	brmi gun1
;=======================
	add freqL, temp1	;    
	adc freqM, temp2
	adc freqH, temp3
		
	ldi temp1, $30		;3000.0 khz
	ldi temp2, $75
	ldi temp3, $00
	
	sub freqL, temp1	;low
	sbc freqM, temp2	;high
	sbc freqH, temp3	;high
	brmi gun2
;=======================
	add freqL, temp1	;    
	adc freqM, temp2
	adc freqH, temp3
	
	ldi temp1, $40		;4000.0 khz
	ldi temp2, $9c
	ldi temp3, $00
	
	sub freqL, temp1	;low
	sbc freqM, temp2	;high
	sbc freqH, temp3	;high
	brmi gun3
;=======================
	add freqL, temp1	;    
	adc freqM, temp2
	adc freqH, temp3
	
	ldi temp1, $50		;5000.0 khz
	ldi temp2, $c3
	ldi temp3, $00
	
	sub freqL, temp1	;low
	sbc freqM, temp2	;high
	sbc freqH, temp3	;high
	brmi gun4
;=======================
	add freqL, temp1	;    
	adc freqM, temp2
	adc freqH, temp3
	
	ldi temp1, $60		;6000.0 khz
	ldi temp2, $ea
	ldi temp3, $00
	
	sub freqL, temp1	;low
	sbc freqM, temp2	;high
	sbc freqH, temp3	;high
	brmi gun5
;=======================
	add freqL, temp1	;    
	adc freqM, temp2
	adc freqH, temp3
	
	ldi temp1, $70		;7000.0 khz
	ldi temp2, $11
	ldi temp3, $01
	
	sub freqL, temp1	;low
	sbc freqM, temp2	;high
	sbc freqH, temp3	;high
	brmi gun6
;=======================
	add freqL, temp1	;    
	adc freqM, temp2
	adc freqH, temp3
	
	ldi temp1, $90		;9000.0 khz
	ldi temp2, $5f
	ldi temp3, $01
	
	sub freqL, temp1	;low
	sbc freqM, temp2	;high
	sbc freqH, temp3	;high
	brmi gun7
	ret
	
gun1:				;8  -    5000  "1"     1  4
ldi temp1, 0b10000001
mov select, temp1
pop freqH		;     
pop freqM
pop freqL
ret

gun2:
ldi temp1, 0b10000010
mov select, temp1
pop freqH		;     
pop freqM
pop freqL
ret

gun3:
ldi temp1, 0b10000100
mov select, temp1
pop freqH		;     
pop freqM
pop freqL
ret

gun4:
ldi temp1, 0b10001000
mov select, temp1
pop freqH		;     
pop freqM
pop freqL
ret

gun5:				;8  -    8500  "0"     5  7
ldi temp1, 0b00010000
mov select, temp1
pop freqH		;     
pop freqM
pop freqL
ret

gun6:
ldi temp1, 0b00100000
mov select, temp1
pop freqH		;     
pop freqM
pop freqL
ret

gun7:
ldi temp1, 0b01000000
mov select, temp1
pop freqH		;     
pop freqM
pop freqL
ret


;***********************************************************************************
;    100 
select_hz:

;  
ret
;  

	lds temp1, Digits+4	; 
	
	cpi temp1, 0
	breq f000hz
	cpi temp1, 1
	breq f100hz
	cpi temp1, 2
	breq f200hz
	cpi temp1, 3
	breq f300hz
	cpi temp1, 4
	breq f400hz
	cpi temp1, 5
	breq f500hz
	cpi temp1, 6
	breq f600hz
	cpi temp1, 7
	breq f700hz
	cpi temp1, 8
	breq f800hz
	cpi temp1, 9
	breq f900hz
	ret
	
f000hz:
ldi temp2, 255
ret

f100hz:
ldi temp2, 243
ret

f200hz:
ldi temp2, 230
ret

f300hz:
ldi temp2, 214
ret

f400hz:
ldi temp2, 201
ret

f500hz:
ldi temp2, 184
ret

f600hz:
ldi temp2, 171
ret

f700hz:
ldi temp2, 151
ret

f800hz:
ldi temp2, 107
ret

f900hz:
ldi temp2, 47
ret




	
;=================================================
DcMatrix:
		; hgfedcba    hgfedcba
	.db 	0b11000000, 0b11111001	;0,1
	.db 	0b10100100, 0b10110000	;2,3
	.db 	0b10011001, 0b10010010	;4,5
	.db 	0b10000010, 0b11111000	;6,7
	.db 	0b10000000, 0b10010000	;8,9

;decimal:
;		;       01    23456789
;	.db 	0b00000010, 0b00000000	;0
;	.db 	0b00000001, 0b00000000	;1
;	.db 	0b00000000, 0b10000000	;2
;	.db 	0b00000000, 0b01000000	;3
;	.db 	0b00000000, 0b00100000	;4
;	.db 	0b00000000, 0b00010000	;5
;	.db 	0b00000000, 0b00001000	;6
;	.db 	0b00000000, 0b00000100	;7
;	.db 	0b00000000, 0b00000010	;8
;	.db 	0b00000000, 0b00000001	;9


